require 'omniauth/strategies/oauth2'
require 'uri'

module OmniAuth
  module Strategies
    class Pacreception < OmniAuth::Strategies::OAuth2
        # class NoAuthorizationCodeError < StandardError; en                
        DEFAULT_SCOPE = 'public'

        option :name, :pacreception

        option :client_options, {
          site: "https://www.pacreception.com"
        }

        option :authorize_options, [:scope, :auth_type]

        uid {  raw_info['user']['id']  }
    
        info do
          prune!({
            'email' => raw_info['user']['email'],
            'name' => "#{raw_info['user']['first_name']} #{raw_info['user']['last_name']}"
          })
        end

        extra do 
          hash = {}
          hash['raw_info'] = raw_info unless skip_info?
          prune! hash
        end 

        def raw_info
          @raw_info ||= access_token.get('/api/v1/me').parsed
        end

        def authorize_params
          super.tap do |params|
            %w[scope auth_type].each do |v|
                    if request.params[v]
                        params[v.to_sym] = request.params[v]
                    end
            end
            params[:scope] ||= DEFAULT_SCOPE
          end
        end 

        def callback_url
          options[:callback_url] || super
        end

        def prune!(hash)
          hash.delete_if do |_, value|
            prune!(value) if value.is_a?(Hash)
            value.nil? || (value.respond_to?(:empty?) && value.empty?)
          end
        end
    end
  end
end
